SystemOrganization addCategory: #'DAO-TP-Changes'!

Error subclass: #UnidadDeTrabajoException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

TestCase subclass: #ChangesTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:37'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
autorTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:06'!
cambio01
	^1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:42'!
classAdded: aClass inCategory: aCategoryName 
	(diccionarioDeAcciones at: ClassAdded) value: (ClassAdded class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 13:02'!
classCategoryAdded: unNombreDeCategoria 
	(diccionarioDeAcciones at: CategoryAdded) value: (CategoryAdded categoryName: unNombreDeCategoria).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:16'!
classRemoved: aClass fromCategory: aCategoryName
	( diccionarioDeAcciones at: ClassRemoved ) value: (ClassRemoved class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:48'!
fullName
	^nombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:06'!
fullName: unNombreDelAutor 
	nombreDelAutor := unNombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:37'!
initialize 
	diccionarioDeAcciones := Dictionary new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:10'!
now
	^fechaYHoraTest.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:41'!
on: unTipoDeEvento do: aBlockClosure 
	
	diccionarioDeAcciones at: unTipoDeEvento put: aBlockClosure.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
relojTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:08'!
setear: aDateAndTime 
	fechaYHoraTest := aDateAndTime.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:55'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:07'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo registrarCambio: self cambio01.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self cambio01 ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:53'!
test005UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test006ElSistemaRegistraElCambioEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |

	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios registrarCambio: self cambio01.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 

	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test007ElSistemaAlCerrarLaUnidadActivaNoCreaUnaUnidadNueva
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadActiva estaCerrada .
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:54'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test008ElSistemaAlCerrarLaUnidadActivaSoloTieneUnidadesDeTrabajoCerradas
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: ( unSistemaDeCambios unidadesDeTrabajo allSatisfy: [ :unaUnidadDeTrabajo | unaUnidadDeTrabajo estaCerrada ] ).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 19:37'!
test010ElSistemaDebeCrearUnaUnidadCuandoLaActualEsteCerradaYSeRegistreUnCambio
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada:= self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
			
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unEvento := EventoClassCreated newWithThisName: 'ChangesTest' andThisCategoty: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
	self assert: unSistemaDeCambios todosLosCambios size = 1! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 19:42'!
test011UnCambioDebeSaberEnQueMomentoFueRealizadoYPorQuien
	
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := EventoClassCreated newWithThisName: 'ChangesTest' andThisCategoty: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.

	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio nombreDeClase = 'ChangesTest')
																								and:  unRegistroDeCambio cambio nombreDeCategoria = 'DAO-TP-Changes'] ).
	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 19:45'!
test012ElSistemaRegistraLosCambiosDeTipoClassRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := EventoClassRemoved newWithThisName: 'ChangesTest' andThisCategoty: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio nombreDeClase = 'ChangesTest')
																								and:  unRegistroDeCambio cambio nombreDeCategoria = 'DAO-TP-Changes'] ).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 20:17'!
test013ElSistemaRegistraLosCambiosDeTipoClassRecategorized
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := EventoClassRecategorized classAffected: 'ChangesTest' fromThisCategoty: 'DAO-TP-Changes-old' to: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio nombreDeClase = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio nombreDeCategoriaVieja = 'DAO-TP-Changes-old').
		self assert: (unRegistroDeCambio cambio nombreDeCategoriaNueva = 'DAO-TP-Changes').
		]! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:11'!
tipoDelCambio01
	^'Agregar'.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:11'!
unSystemAnnouncer
	^self.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 19:43'!
unaInterfaceDeEventosDeEntradaInicializada
	| unAutor unReloj unSistemaDeCambios |
	unReloj := self relojTest.
	unAutor := self autorTest.
	unSistemaDeCambios := SistemaDeCambios new.
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	^InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj! !

Object subclass: #Cambio
	instanceVariableNames: 'tipoDeCambio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!Cambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:25'!
newWithThisUserName: unNombreDeUsuario atThisTime: unaHora withThisEvent: unEvento
	( unEvento isKindOf: ClassAdded ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unEvento classAdded name enLaCategoria: unEvento classCategory ].
	( unEvento isKindOf: ClassRemoved ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora borro: unEvento classRemoved name enLaCategoria: unEvento categoryName ].
	( unEvento isKindOf: CategoryAdded ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creoLaCategoria: unEvento categoryName ].
	( unEvento = 'classAdded' ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unEvento enLaCategoria: unEvento ]! !

Cambio subclass: #CambioClaseAgregada
	instanceVariableNames: 'nombreDeClase nombreDeLaCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!CambioClaseAgregada class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:48'!
newWithThisClassName: unNombreDeClase inThisCategory: unNombreDeCategoria 
	^self new initializeWithThisClassName: unNombreDeClase  andThisCategory: unNombreDeCategoria.! !

!CambioClaseAgregada class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:51'!
newWithThisClassName: nombreDeClase inThisCategory: nombreDeCategoria by: nombreDelAutor at: unaFechaYHora
	^self new initializeWithThisClassName: nombreDeClase inThisCategory: nombreDeCategoria by: nombreDelAutor at: unaFechaYHora.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:49'!
initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria 
	nombreDeClase := unNombreDeClase.
	nombreDeLaCategoria := unNombreDeCategoria.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:10'!
nombreDeCategoria
	^nombreDeLaCategoria.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:10'!
nombreDeClase
	^ nombreDeClase! !

Cambio subclass: #CambioClaseRecategorizada
	instanceVariableNames: 'nombreDeClase nombreDeCategoriaVieja nombreDeCategoriaNueva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!CambioClaseRecategorizada class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:12'!
newWithThisClassName: unNombreDeClase from: unNombreDeCategoriaVieja to: unNombreDeCategoriaNueva
	^self new initializeWithThisClassName: unNombreDeClase from: unNombreDeCategoriaVieja to: unNombreDeCategoriaNueva.
	! !

!CambioClaseRecategorizada methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:13'!
initializeWithThisClassName: aByteString from: aByteString2 to: aByteString3 
	self shouldBeImplemented.! !

!CambioClaseRecategorizada methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:14'!
nombreDeCategoriaNueva
	^ nombreDeCategoriaNueva! !

!CambioClaseRecategorizada methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:14'!
nombreDeCategoriaVieja
	^ nombreDeCategoriaVieja! !

!CambioClaseRecategorizada methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:14'!
nombreDeClase
	^ nombreDeClase! !

Cambio subclass: #CambioClaseRemovida
	instanceVariableNames: 'nombreDeClase nombreDeLaCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!CambioClaseRemovida methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:47'!
initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria 
	nombreDeClase := unNombreDeClase.
	nombreDeLaCategoria := unNombreDeCategoria.! !

!CambioClaseRemovida methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:48'!
nombreDeCategoria
	^nombreDeLaCategoria.! !

!CambioClaseRemovida methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:48'!
nombreDeClase
	^ nombreDeClase! !

Object subclass: #Evento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Evento subclass: #EventoClassCreated
	instanceVariableNames: 'nombreDeClase nombreDeCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!EventoClassCreated class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:45'!
newWithThisName: unNombreDeClase andThisCategoty: unNombreDeCategoria 
	^self new initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria.! !

!EventoClassCreated methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:30'!
initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoria := unNombreDeCategoria.! !

!EventoClassCreated methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:07'!
nombreDeCategoria
	^nombreDeCategoria.! !

!EventoClassCreated methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:07'!
nombreDeClase
	^nombreDeClase.! !

Evento subclass: #EventoClassRecategorized
	instanceVariableNames: 'nombreDeClase nombreDeCategoriaVieja nombreDeCategoriaNueva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!EventoClassRecategorized class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:58'!
classAffected: unNombreDeClase fromThisCategoty: nombreDeLaCategoriaVieja to: nombreDeLaCategoriaNueva 
	^self new initializeClassAffected: unNombreDeClase fromThisCategoty: nombreDeLaCategoriaVieja to: nombreDeLaCategoriaNueva.! !

!EventoClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:10'!
initializeClassAffected: unNombreDeClase fromThisCategoty: nombreDeLaCategoriaVieja to: nombreDeLaCategoriaNueva.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoriaVieja := nombreDeLaCategoriaVieja.
	nombreDeCategoriaNueva  := nombreDeLaCategoriaNueva.
! !

!EventoClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:08'!
nombreDeCategoriaNueva
	^nombreDeCategoriaNueva.! !

!EventoClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:08'!
nombreDeCategoriaVieja
	^nombreDeCategoriaVieja.! !

!EventoClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:08'!
nombreDeClase
	^nombreDeClase.! !

Evento subclass: #EventoClassRemoved
	instanceVariableNames: 'nombreDeClase nombreDeCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!EventoClassRemoved class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:15'!
newWithThisName: unNombreDeClase andThisCategoty: unNombreDeCategoria 
	^self new initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria.! !

!EventoClassRemoved methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:20'!
initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoria := unNombreDeCategoria.! !

!EventoClassRemoved methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:07'!
nombreDeCategoria
	^nombreDeCategoria.! !

!EventoClassRemoved methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:07'!
nombreDeClase
	^nombreDeClase.! !

Object subclass: #InterfaceDeEntradaDelSistemaDeCambios
	instanceVariableNames: 'sistemaDeCambios autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfaceDeEntradaDelSistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj 
	^self new initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:52'!
agregarCambio: unCambio por: unNombreDeAutor enElMomento: unaFechaYHora 

	sistemaDeCambios registrarCambio: (RegistroDeCambio newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 20:07'!
handle: unEventoDeLainterface 
	(unEventoDeLainterface isKindOf: EventoClassRecategorized )
	ifTrue: [
		self agregarCambio: (CambioClaseRecategorizada newWithThisClassName: unEventoDeLainterface nombreDeClase from: unEventoDeLainterface nombreDeCategoriaVieja to: unEventoDeLainterface nombreDeCategoriaNueva ) por: autor fullName enElMomento: reloj now 
		 ]
	ifFalse: [ 
		self agregarCambio: (CambioClaseAgregada newWithThisClassName: unEventoDeLainterface nombreDeClase inThisCategory: unEventoDeLainterface nombreDeCategoria ) por: autor fullName 		enElMomento: reloj now ]! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj
	sistemaDeCambios := unSistemaDeCambios.
	autor := unAutor.
	reloj := unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:39'!
sistemaDeCambios
	^ sistemaDeCambios! !

Object subclass: #RegistroDeCambio
	instanceVariableNames: 'cambio autor fechaYHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!RegistroDeCambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:54'!
newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	^self new initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
autor
	^ autor! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 18:04'!
cambio
	^ cambio! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
fechaYHora
	^ fechaYHora! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:58'!
initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	cambio := unCambio.
	autor := unNombreDeAutor.
	fechaYHora := unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:18'!
tipoDeCambio
	^'classRemoved'.! !

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/24/2013 21:53'!
cerrarUnidadDeTrabajoActiva
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:34'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoReal new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 21:12'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	
	[ unidadDeTrabajoActiva registrarCambio: unCambio]
		on: UnidadDeTrabajoException
		do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadDeTrabajoActiva.
		unidadesDeTrabajoCerradas  add: unidadDeTrabajoActiva.
		unidadDeTrabajoActiva := nuevaUnidadActiva.
		unidadDeTrabajoActiva registrarCambio: unCambio ].
! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:10'!
todosLosCambios
	^self unidadActiva todosLosCambios.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:29'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ UnidadDeTrabajoException  signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
todosLosCambios
	^cambios.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !
